<?
/* Mmmm !!! A database-driven website with HTML/php3/mySQL
 * (C) Copyright Pierre Dittgen	1999-2000
 * Pierre.Dittgen@bigfoot.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *                         
 * This program is distributed in the hope that it will entertaining,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.   
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	if (!isset($HEADER_CLASS_COMMENTAIRE_BD)):
		$HEADER_CLASS_COMMENTAIRE_BD=1;

	// La base de donnes
	require "class_bd.php3";

	// Une classe commentaire pour grer les commentaires 
	// avec leurs infos associes
	class commentaireBd extends bd {

		// Constructeur
		function commentaireBd()
		{
			$this->bd();
		}

		function GetCommentaireResult()
		{
			return $this->get_next_row();
		}

		function GetCommentairesSurResto($id, $where)
		{
			// Sur quelle table travaille-t-on ?
			switch ($where)
			{
				case 'prod':	$table = 'comments';			break;
				case 'tempA':	$table = 'comments_associes';	break;
				case 'tempS':	$table = 'comments_seuls';		break;
			}

			return $this->execute("select * from $table where resto_id = $id order by date_entree");
		}

		// Combien de commentaires dans la base
		function GetNbComments($where = 'prod')
		{
			// Sur quelle table travaille-t-on ?
			switch ($where)
			{
				case 'prod':	$table = 'comments';			break;
				case 'tempA':	$table = 'comments_associes';	break;
				case 'tempS':	$table = 'comments_seuls';		break;
			}

			$this->execute("select count(*) from $table");
			$result = $this->get_next_row();
			return $result['count(*)'];
		}

		function GetCommentairesEnAttente()
		{
			return $this->execute('select * from comments_seuls');
		}

		function GetCommentaireById($id, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			switch ($where)
			{
				case 'prod':	$table = 'comments';			break;
				case 'tempA':	$table = 'comments_associes';	break;
				case 'tempS':	$table = 'comments_seuls';		break;
			}

			$nb = $this->execute("select * from $table where id = $id");
			if ($nb != 1)
				return false;

			return $this->get_next_row();
		}

		function GetContributeurs()
		{
			$nb	= $this->execute("select pseudo from comments group by 1");
			for ($c=0; $c<$nb; $c++)
			{
				$tmp = $this->get_next_row();
				$list[] = $tmp['pseudo'];
			}

			return $list;
		}

		function GetListeAvisSurResto($id, $base='prod')
		{
			// On ne tape pas dans la meme table en fonction de la base
			// ou on est...
			if ($base == 'prod')
					$table = 'comments';
			else	$table = 'comments_associes';

			// Rcupration des avis associs
			$nb = $this->execute("select avis from $table where resto_id = $id");
			while ($nb > 0)
			{
				$brut = $this->get_next_row();
				$list[] = $brut['avis'];
				$nb--;
			}
			return join(",", $list);
		}

		function GetContributeursAvecEmail()
		{
			$nb	= $this->execute("select pseudo, e_mail from comments group by 1,2");
			for ($c=0; $c<$nb; $c++)
			{
				$tmp = $this->get_next_row();
				$list[$c]['pseudo'] = $tmp['pseudo'];
				$list[$c]['e_mail'] = $tmp['e_mail'];
			}

			return $list;
		}

		function GetScores()
		{
			// Rcupre les commentaires (id du resto, nom de la personne)
			$nb = $this->execute('select resto_id, pseudo from comments order by date_entree');

			// Pour chaque couple
			for ($c=0; $c<$nb; $c++)
			{
				$tmp	= $this->get_next_row();
				$resto	= $tmp['resto_id'];
				$nom	= $tmp['pseudo'];
				$nommin = strtolower($nom);

				// Le hash CASSE rgle les problmes de Majuscules/Minuscules
				// qui posait problme pour le cumul des points
				if ($CASSE[$nommin] == "")
					$CASSE[$nommin] = $nom;

				// La personne a t-elle rentr le resto (=1er commentaire)
				// ou un commentaire additionnel ?
				if ($RESTOS[$resto] == "")
						$scores[$CASSE[$nommin]]['restos']++;
				else	$scores[$CASSE[$nommin]]['commentaires']++;
				$RESTOS[$resto]++;
			}
			return $scores;
		}
		
		// Ajouter un resto dans la liste 
		function AddCommentaire($comm, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			switch ($where)
			{
				case 'prod':	$table = 'comments';			break;
				case 'tempA':	$table = 'comments_associes';	break;
				case 'tempS':	$table = 'comments_seuls';		break;
			}

			// Trouver un identifiant ok
			$this->execute("select max(id) from $table");
			$tmp	= $this->get_next_row();
			$id		= $tmp['max(id)'] + 1;

			// Prparer la requ^ete
			$query	= "insert into $table ";
			$query	.= '(id, date_entree, pseudo, e_mail, prive, resto_id, commentaire, avis) ';

			// On l'instancie
			$values	= sprintf('values (%d, %s, "%s", "%s", %d, %d, "%s", %s)', 
							$id, 
							$comm['date_entree'], $comm['pseudo'],
							$comm['e_mail'], $comm['prive'],
							$comm['resto_id'], addSlashes($comm['commentaire']),
							$comm['avis']);
			$query .= $values;

			// Enfin, on l'execute...
			$this->execute($query);
			return $id;
		}

		function DeleteCommentaire($id, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			switch ($where)
			{
				case 'prod':	$table='comments';			break;
				case 'tempA':	$table='comments_associes';	break;
				case 'tempS':	$table='comments_seuls';	break;
			}

			$this->execute("delete from $table where id = $id");
		}

		function DeleteCommentaireAssociatedToResto($resto_id, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			switch ($where)
			{
				case 'prod':	$table='comments';			break;
				case 'tempA':	$table='comments_associes';	break;
				case 'tempS':	$table='comments_seuls';	break;
			}

			$this->execute("delete from $table where resto_id = $resto_id");
		}
	}

	endif;	// isset()
?>
