<?
/* Mmmm !!! A database-driven website with HTML/php3/mySQL
 * (C) Copyright Pierre Dittgen	1999-2000
 * Pierre.Dittgen@bigfoot.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *                         
 * This program is distributed in the hope that it will entertaining,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.   
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	if (!isset($HEADER_CLASS_RESTO)):
	$HEADER_CLASS_BD=1;

	require "class_data.php3";
	require "const_resto.php3";

	class Resto extends DataObject {

		// Pour l'criture ou non dans un fichier
		var $toFile = false;
		var $fd = 0;

		// Constructeur
		function Resto($data = "")
		{
			$fields = array('nom', 'adresse', 'telephone', 'region', 'horaires',
							'metro', 'genre', 'taille', 'ambiance', 'prix',
							'date_entree', 'image', 'iti', 'avis', 'ville', 'pays');

			if ($data == "")
					$this->DataObject($fields);
			else	$this->DataObject($data, 'assoc');
			$listeAvis = "";
		}

		// vrifie les infos et renvoie un boolen indiquant
		// la validit des infos
		function infosOk()
		{
			$this->err	= "";
			$this->warn	= "";
			$ok			= true;

			if ($this->get('nom') == "")
			{ $ok=false; $this->err[] = "Vous avez oubli le nom du resto !"; }
			if ($this->get('adresse') == "")
			{ $ok=false; $this->err[] = "Vous n'avez pas indiqu l'adresse du resto !"; }
			if (($this->get('ville') == "") && ($this->get('region') > 20))
			{ $ok=false; $this->err[] = "Vous n'avez pas indiqu la ville du resto !"; }
			if (($this->get('pays') == "") && ($this->get('region') == 26))
			{ $ok=false; $this->err[] = "Vous n'avez pas indiqu le pays du resto !"; }
			if ($this->get('telephone') == "")
			{ $this->warn[] = "Le numro de tlphone est absent..."; }
			if ($this->get('horaires') == "")
			{ $this->warn[] = "Les horaires d'ouverture sont absents..."; }
			if ($this->get('region') == 0)
			{ $this->warn[] = "L'arrondissement ou la rgion est absent..."; }
			if ($this->get('metro') == "" && $this->get('region') < 21)
			{ $this->warn[] = "La station de mtro est absente..."; }
			if ($this->get('genre') == "")
			{ $this->warn[] = "Le type de resto est manquant..."; }

			return $ok;
		}

		function printDetail()
		{
			// Tableau de libells
			global $libelleArrdt, $tailleResto, $ambianceResto, $prixResto;

			printf("Restaurant <b>%s</b><br>\n", infoForm($this->get('nom')));
			printf("Adresse : %s<br>\n",
					infoForm($this->get('adresse')));
			printf("Ville : %s<br>\n",
					infoForm($this->get('ville')));
			printf("Pays : %s<br>\n",
					infoForm($this->get('pays')));
			printf("Arrondissement/rgion : %s<br>\n",
					$libelleArrdt[$this->get('region')]);
			printf("Tlphone : %s<br>\n", infoForm($this->get('telephone')));
			printf("Horaires : %s<br>\n", infoForm($this->get('horaires')));
			printf("Mtro : %s<br>\n",
				infoForm($this->get('metro'), $this->get('region')<21));
			printf("Type ou spcialits : %s<br>\n", infoForm($this->get('genre')));
			printf("Taille : %s<br>\n", $tailleResto[$this->get('taille')]);
			printf("Ambiance : %s<br>\n", $ambianceResto[$this->get('ambiance')]);
			printf("Prix : %s<br>\n", $prixResto[$this->get('prix')]);
		}

		function toFile($fd)
		{
			$this->toFile = true;
			$this->fd = $fd;
		}

		function printResume($affichage = "TOTAL")
		{
			global $admin, $HOME_DIR, $PHP_SELF;
			global $iconeAvis, $commentaireAvis;

			$adresse_retour = "$HOME_DIR/" . basepage($PHP_SELF);

			// Nom (avec lien) et genre du resto
			$buffer = "<li>\n";

			// Commentaires
			$listeAvis	= explode(",", $this->get('avis'));
			for ($i=0; $i<sizeof($listeAvis); $i++)
				$buffer .= img($iconeAvis[$listeAvis[$i]],
						 $commentaireAvis[$listeAvis[$i]]) . "\n";
			$buffer .= sprintf("<a href=\"%s?id=%d%s\">%s</a>\n", 
					'/scripts/script_detail_resto.php3', $this->get('id'),
					(isset($admin)) ? "&admin=1" : "",
					$this->get("nom"));
			if ($affichage != "SANS_GENRE" && $affichage != "SHORT")
				$buffer .= sprintf("(%s)\n", last_categorie($this->get("genre")));

			if ($affichage == "SHORT")
			{
				if ($this->toFile)
						fwrite($this->fd, $buffer);
				else	echo $buffer;
				return;
			}

			// Image si nouveau (-1 semaine)
			if (is_new($this->get('date_entree')))
				$buffer .= img('new.png', 'nouveau resto');

			// Lien pour le virer (si administrateur)
			if (isset($admin))
				$buffer .= lien("/admin/scripts/script_del_resto.php3?id="
					. $this->get('id') . "&base=prod&retour="
					. urlencode($adresse_retour) .
					img('/admin/icones/del.png', 'Supprimer le resto'));

			// Adresse (et tlphone)
			$buffer .= "<br>" . $this->get('adresse');
			$buffer .= " / " . $this->get('ville');
			if ($this->get('region') == 26)
				$buffer .= " (" . $this->get('pays') . ")";
			if ($this->get('telephone') != "")
				$buffer .= "<br>Tl. " . $this->get('telephone') . "\n";

			if ($this->toFile)
					fwrite($this->fd, $buffer);
			else	echo $buffer;
		}

		function getNumJour()
		{
			return substr($this->get('date_entree'), 8, 2);
		}

		function getJour()
		{
			return ereg_replace("(....)-(..)-(..).*", "\\3/\\2/\\1", $this->get('date_entree'));
		}

		function rate()
		{
			$count = 0;
			$listeAvis	= explode(",", $this->get('avis'));
			for ($i=0; $i<sizeof($listeAvis); $i++)
			{
				switch ($listeAvis[$i])
				{
					case 0:
						$count -= 5; break;
					case 1:
						$count += 2; break;
					case 2:
						$count += 5; break;
				}
			}
			return $count;
		}
	}

	endif;	// isset()

?>
