<?
/* Mmmm !!! A database-driven website with HTML/php3/mySQL
 * (C) Copyright Pierre Dittgen	1999-2000
 * Pierre.Dittgen@bigfoot.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *                         
 * This program is distributed in the hope that it will entertaining,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.   
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	if (!isset($HEADER_CLASS_RESTO_BD)):
		$HEADER_CLASS_RESTO_BD=1;

	// La base de donnes
	require "class_bd.php3";
	require "class_commentairebd.php3";

	// Une classe resto pour grer les restos avec leurs infos associes
	class restoBd extends bd {

		// Constructeur
		function restoBd()
		{
			$this->bd();
		}

		// Liste des restos en attente
		function GetRestosEnAttente()
		{
			return $this->execute('select * from restos_en_attente order by date_entree');
		}

		function GetRestoResult($base='prod')
		{
			$resto = $this->get_next_row();
			
			// Rcupration des avis associs
			$cb				= new commentaireBd();
			$resto['avis']	= $cb->GetListeAvisSurResto($resto['id'], $base);

			return $resto;
		}

		// Les derniers restos entrs
		function GetDerniersRestos($nb=5)
		{
			return $this->execute("select * from restos order by date_entree desc limit 0, $nb");
		}

		// Les derniers restos mis  jour
		function GetRestosMisAJour($exclus,$nb=5)
		{
			$set = join(",", $exclus);
			$this->execute("select resto_id,count(id),max(date_entree) "
				. "from comments where resto_id not in ($set)"
				. "  group by resto_id having count(id) > 1 "
				. "order by 3 desc limit 0,$nb");
			for ($i=0; $i<$nb; $i++)
			{
				$val = $this->get_next_row();
				$tab[] = $val['resto_id'];
			}
			$set = join(",", $tab);
			
			return $this->execute("select restos.* from restos,comments "
				. "where restos.id in ($set) and restos.id=comments.resto_id "
				. "order by comments.date_entree desc");
		}

		// Combien de restos dans la base ?
		function GetRestos($where = 'prod')
		{
			// Sur quelle table travaille-t-on ?
			$table = ($where == 'prod') ? 'restos' : 'restos_en_attente';

			return $this->execute("select * from $table");
		}

		// Combien de restos dans la base
		function GetNbRestos($where = 'prod')
		{
			// Sur quelle table travaille-t-on ?
			$table = ($where == 'prod') ? 'restos' : 'restos_en_attente';

			$this->execute("select count(*) from $table");
			$result = $this->get_next_row();
			return $result['count(*)'];
		}

		// Les restos incomplet
		function GetRestosIncomplet($field)
		{
			// Restos dont le champ choisi est vide
			return $this->execute("select * from restos where $field='' order by nom");
		}

		// Les restos ajouts ce jour 
		function GetRestosDuJour()
		{
			// Ajourd'hui, nous sommes le ...
			$aujourdhui	= date("Y-m-d");

			return $this->execute("select * from restos where to_days(date_entree) = to_days(\"$aujourdhui\") order by nom");
		}

		// Recherche dans les catgories
		function SearchCategories($categorie)
		{
			// Requte sur les catgories
			$nb = $this->execute("select genre, count(*) from restos where genre like '%$categorie%' group by genre");

			// On boucle dessus
			while ($nb--)
			{
				// Construction du couple (genre, nb)
				$result = $this->get_next_row();
				$couple['cat']	= $result['genre'];
				$couple['nb']	= $result['count(*)'];
				
				// Ajout a la liste de retour
				$list[] = $couple;
			}

			return $list;
		}

		// Les sous-catgories d'une catgories
		function GetSousCategories($categorie)
		{
			// Requte sur les catgories
			if ($categorie != "")	$categorie .= "/";
			$nb = $this->execute("select genre, count(*) from restos where genre like '$categorie%' group by genre");

			// On boucle dessus
			while ($nb > 0)
			{
				// Extraction de la sous-categorie
				$result = $this->get_next_row();
				ereg("$categorie([^/]+)", $result["genre"], $regs);

				// on le met dans le tableau ad hoc
				$dico[$regs[1]] += $result['count(*)'];
				$nb--;
			}

			// S'il n'y a plus de sous-catgories,
			// on s'arrte l...
			if (count($dico) == 0) return array();

			// On parcourt ensuite le dico tri par ordre
			// alphabtique pour construire la liste de retour...
			ksort($dico);
			for(reset($dico); $key = key($dico); next($dico))
			{
				$tmp['cat'] = $key;
				$tmp['nb']	= $dico[$key];
    			$tab[] = $tmp;
			}

			return $tab;
		}

		// Les restos d'une catgorie
		function GetRestosParCategorie($categorie)
		{
			if ($categorie == "") return 0;
			return $this->execute("select * from restos where genre like '$categorie' order by region, nom");
		}

		// Les restos ajouts ce mois 
		function GetRestosDuMois()
		{
			// Ce mois ci
			$cejourla	= date("d");
			$cemoisci	= date("m");
			$cetteannee	= date("Y");

			return $this->execute("select * from restos where month(date_entree) = $cemoisci and year(date_entree) = $cetteannee and dayofmonth(date_entree) <> $cejourla order by date_entree desc, nom");
		}

		// Les restos ajouts depuis 30 jours
		// mais pas du jour !!!
		function GetRestosRecents()
		{
			return $this->execute("select * from restos where (to_days(now()) - to_days(date_entree) <= 30) and (to_days(now()) - to_days(date_entree) <> 0) order by date_entree desc, nom");
		}

		// Liste des rgions comportant un ou plusieurs restos
		function GetRegions()
		{
			$nb = $this->execute('select region from restos group by region');
			for ($i=0; $i<$nb; $i++)
			{
				$tmp = $this->get_next_row();
				$result[$tmp['region']] = 1;
			}
			return $result;
		}

		// Liste des identifiants de restos classs
		// par ordre alphabtique
		function GetRestosParRegion($region = 0)
		{
			$requete	= 'select * from restos ';
			if ($region)
				$requete	.= "where region = $region ";
			// France
			if ($region != 26)
					$requete	.= 'order by region, ville, nom';
			else	$requete	.= 'order by pays, ville, nom';
			return $this->execute($requete);
		}

		// Liste des identifiants de restos classs
		// par ordre alphabtique
		function GetRestosParDepartement()
		{
			$requete	= 'select * from restos ';
			$requete	.= 'order by ville, pays, nom';
			return $this->execute($requete);
		}

		// recherche de restos suivant un critre et un type
		function SearchRestos($critere, $val1, $val2="", $val3="", $val4="", $val5="")
		{
			// On se mfie des caractres bizarres
			if (gettype($val1) != 'array')
				$val1	= addSlashes($val1);
			$val2	= addSlashes($val2);
			$val5	= addSlashes($val5);

			// Requete SQL de recherche de resto
			$requete	= "select distinct restos.id, restos.date_entree, nom, "
						. "adresse, region, metro, telephone, genre, "
						. "taille, ambiance, horaires, prix, ville, "
						. "pays from restos";

			switch ($critere)
			{
				case 'par_nom':
					$requete .= " where nom like '%$val1%'";
					$sorts = "region, ville, nom";
					break;

				case 'par_gourmet':
					$requete .= ", comments where pseudo like '%$val1%' and restos.id = comments.resto_id";
					$sorts = "region, ville, nom";
					break;

				case 'par_date_debut':
					$requete .= " where date_entree > '$val1'";
					$sorts = "region, ville, nom";
					break;

				case 'par_periode':
					$requete .= " where date_entree > '$val1' and date_entree < '$val2'";
					$sorts = "region, ville, nom";
					break;

				case 'par_mot_du_commentaire':
					$requete .= ", comments where commentaire like '%$val1%' and restos.id = comments.resto_id";
					$sorts = "region, ville, nom";
					break;

				case 'par_multi':
					$requete .= " where";
					// region
					if ((count($val1) != 0) && ($val1[0] != '-'))
					{ if ($crit) $requete .= " and"; 
					  $requete .= " (region = " . $val1[0];
					  for ($i=1; $i<count($val1); $i++)
						  $requete .= " or region = " . $val1[$i];
					  $requete .= ")";  $crit++; }
					// taille
					if ($val2 != -1)
					{ if ($crit) $requete .= " and";
					  $requete .= " taille = $val2"; $crit++; }
					// ambiance
					if ($val3 != -1)
					{ if ($crit) $requete .= " and";
					  $requete .= " ambiance = $val3"; $crit++; }
					// prix
					if ($val4 != -1)
					{ if ($crit) $requete .= " and";
					  $requete .= " prix = $val4"; $crit++; }
					// genre
					if ($val5 != -1)
					{ if ($crit) $requete .= " and";
					  $requete .= " genre like '%$val5%'"; $crit++; }
					$sorts = "region, ville, nom";
					break;
			}

			$requete .= " order by $sorts";
			#echo "<font size=+7 color=blue>$requete</font><br>";
			return $this->execute($requete);
		}

		// Rcupre un resto par son identifiant
		function GetRestoById($id, $where='prod')
		{
			// Choisit la table de recherche
			if ($where == 'prod')
					$table = 'restos';
			else	$table = 'restos_en_attente';

			// Requete SQL
			$nb = $this->execute("select * from $table where id = $id");
			if ($nb != 1)
				return false;
			return $this->get_next_row();
		}

		// Ajouter un resto dans la liste 
		function AddResto($resto, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			$table = ($where == 'prod') ? 'restos' : 'restos_en_attente';

			// Trouver un identifiant ok
			$this->execute("select max(id) from $table");
			$tmp	= $this->get_next_row();
			$id		= $tmp['max(id)'] + 1;

			// Prparer la requ^ete
			$query	= "insert into $table ";
			$query	.= '(id, date_entree, nom, adresse, region, metro, telephone, genre, taille, ambiance, horaires, prix, ville, pays) ';

			// On l'instancie
			$values	= sprintf('values (%d, %s, "%s", "%s", %d, "%s", "%s", "%s", %d, %d, "%s", %d, "%s", "%s")', 
							$id, 
							$resto['date_entree'], $resto['nom'],
							$resto['adresse'], $resto['region'],
							$resto['metro'], $resto['telephone'],
							$resto['genre'], $resto['taille'],
							$resto['ambiance'], $resto['horaires'],
							$resto['prix'],
							$resto['ville'], $resto['pays']);
			$query .= $values;

			// Enfin, on l'execute...
			$this->execute($query);
			return $id;
		}

		function DeleteResto($id, $where='prod')
		{
			// Sur quelle table travaille-t-on ?
			$table = ($where == 'prod') ? 'restos' : 'restos_en_attente';

			$this->execute("delete from $table where id = $id");
		}

		// Affiche les restos avec les intituls de rgion,
		// classs et tout et tout...
		// (dpartements inclus...)
		function PrintRestos($nb, $affichage='AVEC_REGIONS')
		{
			include "const_departements.php3";
			include "const_resto.php3";

			$ville = "";
			$depart = "";
			$nouveau_depart = "";
			$etranger = 0;
			$region = "";

			// Lecture des restos un par un
			for ($r=0; $r<$nb; $r++)
			{
				// Constitution du resto (rcupration des infos)
				$resto		= $this->GetRestoResult();
				$o_resto	= new Resto($resto);

				// Region
				if ($affichage == 'AVEC_REGIONS')
				{
					//echo "<font size=+8 color=red>Houalala !!! ($region)</font>";
					if (($region != $o_resto->get('region'))
						&& ($o_resto->get('region') > 20))
					{
						//echo "POOOOOOOOOOOOOOOOOOOOOOOOOOOOOO<br>\n";
						//echo "<hr>\n";
						if (($r > 0) && ($o_resto->get('region') != 26))
							echo "</ul></ul></ul>\n";
						$region = $o_resto->get('region');
						if ($region != 26)
							echo "<h2>$libelleArrdt[$region]</h2>\n<ul>\n";
						$premierRegion = 1;
					}
				}

				// Est-ce en France ?
				if ($o_resto->get('pays') == 'France')
				{
					// Est-ce un nouveau dpartement ?
					if (($depart != substr($o_resto->get('ville'), 0, 2))
					&& ($depart != substr($o_resto->get('ville'), 0, 3)))
					{
						if ($depart && !$premierRegion) echo "</ul></ul>\n";
						$premierRegion = 0;
						$depart = substr($o_resto->get('ville'), 0, 2);
						// Traitement particulier pour les DOM-TOM
						if ($depart == "97")
							$depart = substr($o_resto->get('ville'), 0, 3);
						echo "<h2>$departement[$depart] ($depart)</h2>\n";
						echo "<ul>\n";
						$nouveau_depart = 1;
					}
				}
				// C'est  l'tranger
				else
				{
					// Si c'est le premier resto
					if (!$etranger)
					{
						$etranger = 1;
						if ($depart != "")
							echo "</ul></ul></ul>";
						echo "<h2>Etranger</h2>\n<ul>\n";
						$depart = "";
					}

					// Est-ce un nouveau pays ?
					if ($depart != $o_resto->get('pays'))
					{
						if ($depart) echo "</ul>\n";
						$depart = $o_resto->get('pays');
						echo "<h3>$depart</h3>\n";
						echo "<ul>\n";
						$nouveau_depart = 1;
					}

				}
				//endif;	


				if ($o_resto->get('pays') == 'France')
				{
					// Est-ce une nouvelle ville ?
					if ($ville != $o_resto->get('ville'))
					{
						if (($ville) && (!$nouveau_depart))
								echo "</ul>\n";
						else	$nouveau_depart = 0;
						$ville = $o_resto->get('ville');
						$pretty_ville = ereg_replace("^([0-9]{5}) (.*)", "\\2 (\\1)", $ville);
						echo "<h3>$pretty_ville</h3>\n";
						echo "<ul>\n";
					}
				}
			
				// Affichage du resto
				$o_resto->printResume();
			}

		}

		function BindImage($id, $image)
		{
			$this->execute("update restos set image='$image' where id=$id");
		}

		function GetRestosParGourmet($gourmet)
		{
			$nb = $this->execute("select resto_id, avis from comments where pseudo='$gourmet' order by avis desc");
			for ($i=0; $i<$nb; $i++)
			{
				$row = $this->get_next_row();
				if ($liste[$row['avis']]['requete'] == "")
						$liste[$row['avis']] .= " where id in (";
				else	$liste[$row['avis']] .= ",";
				$liste[$row['avis']] .= $row['resto_id'];
			}
			for ($i=0; $i<3; $i++)
				if ($liste[$i] != "")
					$liste[$i] .= ")";
			return $liste;
		}

		function GetRestosParGourmetEtAvis($gourmet, $avis)
		{
			if ($avis == "")
				return 0;
			return $this->execute("select * from restos $avis");
		}
	}

	endif; // isset()
?>
