<?
/* Mmmm !!! A database-driven website with HTML/php3/mySQL
 * (C) Copyright Pierre Dittgen	1999-2000
 * Pierre.Dittgen@bigfoot.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public Licences as by published
 * by the Free Software Foundation; either version 2; or (at your option)
 * any later version
 *                         
 * This program is distributed in the hope that it will entertaining,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILTY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.   
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	if (!isset($HEADER_CLASS_BATCH)):
		$HEADER_CLASS_BATCH=1;

	// La base de donnes
	require "class_bd.php3";
	require "class_resto.php3";
	require "class_restobd.php3";

	// Une classe batch pour grer les traitements qui sont
	// faits une fois de temps en temps (lors d'une modification
	// dans la base par exemple).

	class Batch {

		// Constructeur
		function Batch()
		{
		}

		// Appelle la mthode de traitement et retourne le nb de secondes
		// ncessaires au traitement...
		function run()
		{
			$before = time();
			$this->doIt();
			$after = time();
			return $after - $before;
		}

		// Les mthodes  driver
		function doIt() 	{}
		function intitule() { return "Tche anonyme!"; }
	}

	class TimeStone
	{
		var $current;

		function TimeStone()
		{
			$this->current = time();
		}

		function witness()
		{
			echo "Time elapsed = ", time() - $this->current, "<br>\n";
		}
	}

	// Calcul des derniers restos
	class AccueilBatch extends Batch
	{
		function AccueilBatch()
		{
			$this->Batch();
		}

		function intitule()
		{ return "Gnration du code HTML de la page d'accueil"; }

		// Genere un fichier HTML qui contiendra les derniers restos
		// rentrs et les derniers restos mis  jour
		function doIt()
		{
			$bd = new restoBd();

			/**
			 * Gnration des 5 derniers restos rentrs
			 */
			$fd = fopen("genere/derniers_restos.html", "w");
			fwrite($fd, "Dernier resto ajout\n");

            $bd->execute("select * from restos order by date_entree desc limit 0, 5");
    		$resto	 = $bd->GetRestoResult();
    		$o_resto = new Resto($resto, 'array');
    		fwrite($fd, dateToFr($resto['date_entree']));
			fwrite($fd, "\n<hr>\n");
			fwrite($fd, "Les 5 derniers restos entrs sur Mmmm !!!\n");
			$o_resto->toFile($fd);
			$o_resto->printResume("SHORT");
    		$exclus[]   = $o_resto->get('id');

    		// Lecture des restos un par un
    		for ($r=1; $r<5; $r++)
    		{
        		$resto  = $bd->GetRestoResult();

        		$o_resto    = new Resto($resto, 'array');
				$o_resto->toFile($fd);
        		$o_resto->printResume("SHORT");
        		$exclus[]   = $o_resto->get('id');
    		}
			fclose($fd);

			/**
			 * Maintenant les 5 derniers restos mis  jour...
			 */
			$fd = fopen("genere/restos_misajour.html", "w");
			fwrite($fd, "Dernier resto ajout\n");

            $set = join(",", $exclus);
            $bd->execute("select resto_id,count(id),max(date_entree) from comments where resto_id not in ($set) group by resto_id having count(id) > 1 order by 3 desc limit 0,5");
            for ($i=0; $i<5; $i++)
            {
                $val = $bd->get_next_row();
                $tab[] = $val['resto_id'];
            }
            $set = join(",", $tab);
            $nb = $bd->execute("select restos.* from restos,comments where restos.id in (195,373,385,41,82) and restos.id=comments.resto_id order by comments.date_entree desc");
			fwrite($fd, "Les 5 derniers restos mis  jour sur Mmmm !!!\n");

    		// Lecture des restos un par un
    		for ($r=1; $r<$nb; $r++)
    		{
        		$resto  = $bd->GetRestoResult();
        		$o_resto    = new Resto($resto, 'array');

				if ($unique[$o_resto->get('id')] == "")
				{
					$o_resto->toFile($fd);
					$o_resto->printResume("SHORT");
					$unique[$o_resto->get('id')] = 1;
				}
    		}
			fclose($fd);

			/**
			 * Les catgories des restos...
			 */
			$fd = fopen("genere/categories.html", "w");

		    // Rcupration des premires catgories
    		$categories = $bd->GetSousCategories("");
   
    		// Et affichage 
    		for ($cat=0; $cat < count($categories); $cat++)
    		{
        		$buffer = sprintf("<li> <a href=\"scripts/script_categories.php3?categorie=%s\">%s</a> <font size=-2>(%d restos)</font>\n",
            		urlencode($categories[$cat]['cat']),
            		$categories[$cat]["cat"], $categories[$cat]["nb"]);
				fwrite($fd, $buffer);
    		}
			fclose($fd);

		}
	}

	class Elt
	{
		var	$obj;
		var	$weight;

		function Elt($obj, $elt)
		{
			$this->obj = $obj;
			$this->elt = $elt;
		}

		function getObj()
		{
			return $this->obj;
		}

		function getWeight()
		{
			return $this->weight;
		}
	}

	function compareElt($elt1, $elt2)
	{
		if ($elt1->getWeight() == $elt2->getWeight())
			return 0;
		return ($elt1->getWeight() > $elt2->getWeight()) ? 1 : -1;
	}

	class Set
	{
		var $size;
		var $nb;
		var $min;
		var $tab;

		function Set($size)
		{
			$this->size = $size;
			$this->num  = 0;
		}

		function add($elt, $pts)
		{
			if ($this->nb < $this->size)
			{
				$this->tab[] = new Elt($elt,$pts);
				if (($this->nb == 0) || ($pts < $this->min))
					$this->min = $pts;
				$this->nb++;
			}
			else if ($pts > $this->min)
			{
				uasort($this->tab, compareElt);
				$this->tab[0] = new Elt($elt, $points);
				$tmp = $this->tab[1];
				$this->min = $tmp->getWeight();
			}
		}

		function getResult($fd)
		{
			$i = 0;
			ksort($this->tab);
			while (list($k,$v) = each($this->tab))
			{
				echo "K == $k, V == $v<br>\n";
				$list[$i] = $v;
				$i++;
				$resto = $v->getObj();
				$resto->toFile($fd);
				$resto->printResume("SHORT");
			}
			return $list;	
		}
	}

	// Calcul des 10 premiers restos de la liste
	class TopTenBatch extends Batch
	{
		function TopTenBatch()
		{
			$this->Batch();
		}

		function intitule()
		{ return "Calcul du Top ten"; }

		function doIt()
		{
			//$fd = fopen("genere/top_ten.html", "w");
			$fd2 = fopen("genere/top_ten.txt", "w");

			$bd = new restoBd();
			//$bd->execute("delete * from top_restos");
			$nb = $bd->execute("select * from restos");

			//$set = new Set(10);
			while ($nb--)
			{
				$resto = $bd->GetRestoResult();
				$o_resto = new Resto($resto);
				$points  = $o_resto->rate();
				$nom	 = $o_resto->get('nom');
//				$set->add($o_resto, $points);
				fwrite($fd2, "$points:$nom\n");
					//sprintf("insert into topten (points,resto) values ($points, '%s');\n", addSlashes($nom)));
			}

			//$result = $set->getResult($fd);
			/*
			for ($i=0; $i<10; $i++)
			{
				$o_resto = $result[$i];
				$o_resto->toFile($fd);
				$o_resto->printResume();
			}
			*/
	
			//fclose($fd);
			fclose($fd2);
		}
	}

	endif; // isset()
?>
